{Written by Hunter Beanland. http://www.geocities.com/SiliconValley/Lab/1672/
 Please do not delete these lines!}
program fs;  { File Select v1.0 }

uses dos,crt,tools,screen;
{$M 4500,0,0}

const
 runmaskstr='*.COM;*.EXE;*.BAT';

type
 listtype= record
  name:string[8];
  ext:string[3];
  size:longint;
  time:longint;
  tag:integer;
  stat:byte;
 end;

var
 runmask,runall:boolean;
 maskstr,exefile:string[40];
 mask:array[1..10] of string[12];
 pstr:array[1..20] of string[60];
 params,path:string[80];
 ext:string[3];
 list:array[1..650] of listtype;
 tagged,lpos,spos,dot,i,n,q,pc,num,fnum:integer;
 filesp:searchrec;
 time:longint;
 dt:datetime;
 mine,days,mont,ap:string[1];
 winb:pointer;
 drv:byte;
 res:word;

procedure stop(code:byte);       { halt program & restore system }
begin
 textattr:=7;
 window(1,1,80,25);
{ clrscr;}
 if code>0 then write('FileSelect: ');
 case code of
  5: writeln('User aborted');
 end;
 cuon;
 halt(code);
end;

procedure findinput;      { makes sense of input line }
begin
 pc:=paramcount;
 if pc=0 then begin               {no params, list progs}
  maskstr:=runmaskstr;
  runmask:=true;
  exit;
 end;
 for q:=1 to pc do begin
  pstr[q]:=paramstr(q);
  upstr(pstr[q]);
 end;
 if pstr[pc]='/A' then begin       {/A switch?}
  pc:=pc-1;
  runall:=true;
  if pc=0 then exit;
 end;
 if pos('.',pstr[pc])>0 then begin  {is it a mask?}
  maskstr:=pstr[pc];
  pc:=pc-1;
  if pc=0 then begin              {it's a run mask}
   runmask:=true;
   exit;
  end;
 end
 else maskstr:='*.*';
 exefile:=pstr[1];                {runfile}
 if pc>1 then
  for q:=2 to pc do
   params:=params+pstr[q];        {other params}
end;

procedure init;           { init program }
begin
 path:='';
 runall:=false;
 runmask:=false;
 params:='';
 findinput;
end;

procedure importfile;
begin
  if ((filesp.attr and directory)=directory)
  or ((filesp.attr and volumeid)=volumeid) then begin
   num:=num-1;
   exit
  end;
  list[num].name:=copy(filesp.name,1,pos('.',filesp.name)-1);
  list[num].ext:=copy(filesp.name,pos('.',filesp.name)+1,3);
  list[num].size:=filesp.size;
  list[num].time:=filesp.time;
  list[num].tag:=0;
  list[num].stat:=0;
end;

procedure importdir;
begin
  if (filesp.attr and $10)=$10 then begin
   if pos('.',filesp.name)=1 then begin num:=num-1; exit; end;
   if pos('.',filesp.name)>1 then begin
    list[num].name:=copy(filesp.name,1,pos('.',filesp.name)-1);
    list[num].ext:=copy(filesp.name,pos('.',filesp.name)+1,3);
   end else begin
    list[num].name:=filesp.name;
    list[num].ext:='';
   end;
   list[num].stat:=1;
  end else num:=num-1;
end;

procedure getfiles;          { find all files, call importfiles }
begin
 i:=1;
 num:=1;
 mask[1]:='';
 for q:=1 to length(maskstr) do begin
  if (maskstr[q]=';') or (maskstr[q]=' ') then begin
   i:=i+1;
   mask[i]:='';
  end
  else mask[i]:=mask[i]+maskstr[q];
 end;
 repeat
  findfirst(path+mask[i],anyfile,filesp);
  importfile;
  while (doserror=0) do begin
   num:=num+1;
   if num>600 then begin
    num:=600;
    exit;
   end;
   findnext(filesp);
   importfile;
  end;
  i:=i-1;
 until (i=0);
 if num<2 then num:=2;
 fnum:=num-2;
 list[num-1].name:='..';
 list[num-1].ext:='';
 list[num-1].stat:=1;
 findfirst(path+'*.*',directory,filesp);
 importdir;
 while (doserror=0) do begin
   num:=num+1;
   if num>650 then begin
    num:=650;
    exit;
   end;
   findnext(filesp);
   importdir;
 end;
 if num<0 then num:=0;
 for drv:=1 to 26 do begin
  if drv<3 then res:=0
  else asm
   mov ah, 36h
   mov dl, drv
   int 21h
   mov res, ax
  end;
  if res<>$ffff then begin
   num:=num+1;
   list[num].name:=chr(drv+64)+':';
   list[num].stat:=2;
  end;
 end; {drv search}
end;

procedure sortfiles;            { sort name and ext in ascending order }
var nochange:boolean;
    temp:listtype;
begin
 repeat
  nochange := true;
  for n:=1 to fnum-1 do
   if list[n].ext > list[n+1].ext then begin
     temp:= list[n];
     list[n]:= list[n+1];
     list[n+1]:= temp;
     nochange:= false;
   end else
     if list[n].ext= list[n+1].ext then
      if list[n].name > list[n+1].name then begin
        temp:= list[n];
        list[n]:= list[n+1];
        list[n+1]:= temp;
        nochange:= false;
      end;
 until nochange;
end;

procedure renumber;       { renumber all tags after removing missing # }
var lastn:integer;
    found:boolean;
begin
 lastn:=0;
 repeat
  lastn:=lastn+1;
  found:=false;
  for i:=1 to num do
   if list[i].tag=lastn then found:=true;
  if not found then begin
   for i:=1 to num do
    if list[i].tag>lastn then list[i].tag:=list[i].tag-1;
   lastn:=tagged;
  end;
 until lastn=tagged;
end;

procedure timeform(dirln:integer);       { unpack and format time }
begin
unpacktime(list[dirln].time,dt);
with dt do
begin
  ap:='a';
  if hour>11 then
  begin
   ap:='p';
   hour:=hour-12;
  end;
  if hour=0 then hour:=12;
  mine:='';
  mont:='';
  days:='';
  if min<10 then mine:='0';
  if day<10 then days:='0';
  if month<10 then mont:='0';
  year:=year-1900;
  if year>99 then year:=year-100;
end;
end;

procedure writeit(dirln,scrln:integer; hilite:boolean); { write line to screen }
var tagn:integer;
begin
 with dt do
 with list[dirln] do begin
  if hilite then begin
   if stat>0 then textattr:=78
   else textattr:=79;
  end
  else begin
   if stat>0 then textattr:=30
   else textattr:=31;
  end;
  timeform(dirln);
  while length(ext)<3 do
    ext:=ext+#32;
  gotoxy(1,scrln);
  if stat=0 then begin
   if tag=0 then write('   ')
   else write(tag:3);
   write(' ',name,' ':9-length(name),ext);
   write(comma(size):12);
   write('  ',hour:2,':',mine,min,ap,'  ',days,day,'-',mont,month,'-',year);
  end
  else if stat=1 then write('    ',name,' ':9-length(name),ext,' ':30)
  else write('    ',name,' ':40);
 end; {with list}
end;

procedure hilite(ofs:integer);        { move hilite bar }
begin
 if lpos+ofs>num then exit;
 writeit(lpos,spos,false);
 lpos:=lpos+ofs;
 spos:=spos+ofs;
 writeit(lpos,spos,true);
end;

procedure genscreen(lpos2:integer);   { move list according to input }
begin
 for n:=lpos2 to lpos2+22 do begin
   if n>num then n:=lpos2+22
   else writeit(n,n-lpos2+1,false);
 end;
 writeit(lpos,spos,true)
end;

procedure showhelp;            { show help screen then continue }
begin
 textattr:=31;
 clrscr;
 writeln('== FS ==  v1.0  H.Beanland  Copyright 1992'#10);
 writeln('Selection keys are: Enter, Space.');
 writeln('Movement keys are: Up, Dn, PgUp, PgDn,');
 writeln('                   Home, End.');
 writeln('Usage: To run your FS then run ''FS''');
 writeln('       To run program with FS as parameter');
 writeln('       ''FS file *.mod''');
 writeln(#10'Press a key to continue');
 ch:=readkey;
 ch:=#0;
 genscreen(lpos);
end;

procedure askfiles;             { user interface for selection of files }
var lpos2:integer;
begin
 tagged:=0;
 lpos:=1;
 spos:=1;
 genscreen(1);
 repeat
  ch:=readkey;
  case ch of
   #0: begin
        ch:=readkey;
        case ch of
         #59: showhelp;                                  {f1}
         #71: begin                                      {home}
               spos:=1;
               lpos:=1;
               genscreen(1);
              end;
         #72: begin                                      {up}
               if spos=1 then begin
                lpos:=lpos-1;
                if lpos=0 then lpos:=1;
                genscreen(lpos);
               end
               else hilite(-1);
              end;
         #73: begin                                      {pgup}
               if num>23 then begin
                lpos:=lpos-22;
                if lpos-spos<1 then begin
                 lpos:=spos;
                 genscreen(1);
                end
                else genscreen(lpos-spos);
               end;
              end;
         #79: begin                                      {end}
               lpos:=num;
               if num>22 then begin
                spos:=23;
                genscreen(num-22);
               end
               else begin
                spos:=num;
                genscreen(1);
               end;
              end;
         #80: begin                                      {down}
               if spos=23 then begin
                lpos:=lpos+1;
                if lpos>num then lpos:=num;
                genscreen(lpos-22);
               end
               else hilite(1);
              end;
         #81: begin                                      {pgdn}
               if num>23 then begin
                lpos2:=lpos+22-spos;
                if lpos2+22-spos>num-22 then lpos2:=num-22;
                lpos:=lpos2+spos-1;
                genscreen(lpos2);
               end;
              end;
        end;
      end; {#0}
   #27: stop(5);                                         {esc}
   #32: begin                                            {tag-spc}
          if list[lpos].stat=0 then begin
          if list[lpos].tag=0 then begin
           tagged:=tagged+1;
           list[lpos].tag:=tagged
          end
          else begin
           list[lpos].tag:=0;
           tagged:=tagged-1;
           renumber;
          end;
          if spos=23 then begin
           lpos:=lpos+1;
           if lpos>num then lpos:=num;
           genscreen(lpos-22);
          end
          else begin
           lpos:=lpos+1;
           spos:=spos+1;
           if spos=24 then spos:=23;
           if lpos>num then lpos:=num;
           if spos>num then spos:=num;
           if num>22 then genscreen(lpos-spos+1)
           else genscreen(1);
          end;
          end; {file not dir}
        end; {tag}
  end;
 until ch=#13;                                           {enter}
end;

procedure execfile;
var filen:string[80];
begin
  if tagged=0 then filen:=list[lpos].name+'.'+list[lpos].ext;

  writeln('Exec=',exefile,' ',params);
{ exec(exefile,params);}
end;

begin                               { main }
 init;
 repeat
  getfiles;
  cuoff;
  win(32,1,80,25,15,1,1,false,false);
  gotoxy(15,1);
  write(' File Select v1.0 ');
  gotoxy(16,25);
  write(' H.Beanland 1992 ');
  window(33,2,79,24);
  sortfiles;
  askfiles;
  if lpos>fnum then begin
   if list[lpos].name[2]=':' then begin
    path:='';
    list[lpos].ext:='';
   end;
   path:=path+list[lpos].name;
   if (list[lpos].ext<>'') and (list[lpos].ext<>'   ') then path:=path+'.'+list[lpos].ext;
   if path[length(path)]<>':' then path:=path+'\';
  end;
 until lpos<fnum+1;
 execfile;
 stop(0);
end.